package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(IISLSingleSpaceSetMethods_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public interface IISLSingleSpaceSetMethods  extends IISLSingleSpaceMethods, IISLSingleSpaceReadOnlySetMethods {
	
	
	/*** PROTECTED REGION ID(IISLSingleSpaceSetMethods_userCode) ENABLED START ***/
	public default <T extends IISLSingleSpaceSetMethods> T renameIndices(List<String> names) {
		return renameDims(names, ISLDimType.isl_dim_set);
	}
	
	public default <T extends IISLSingleSpaceSetMethods> T addIndices(List<String> names) {
		return addDims(names, ISLDimType.isl_dim_set);
	}

	public default <T extends IISLSingleSpaceSetMethods> T moveParametersToIndices() {
		return moveAllDims(ISLDimType.isl_dim_set, ISLDimType.isl_dim_param);
	}
	
	public default <T extends IISLSingleSpaceSetMethods> T moveIndicesToParameters() {
		return moveAllDims(ISLDimType.isl_dim_param, ISLDimType.isl_dim_set);
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	
}
